﻿using System;

namespace Telerik.Charting
{
    /// <summary>
    /// Represents a component of the <see cref="DateTime"/> structure.
    /// </summary>
    public enum DateTimeComponent
    {
        /// <summary>
        /// The <see cref="DateTime.Ticks"/> component.
        /// </summary>
        Ticks,

        /// <summary>
        /// The <see cref="DateTime.Year"/> component.
        /// </summary>
        Year,

        /// <summary>
        /// The Quarter component.
        /// </summary>
        Quarter,

        /// <summary>
        /// The <see cref="DateTime.Month"/> component.
        /// </summary>
        Month,

        /// <summary>
        /// The Week component.
        /// </summary>
        Week,

        /// <summary>
        /// The <see cref="DateTime.Hour"/> component.
        /// </summary>
        Hour,

        /// <summary>
        /// The <see cref="DateTime.Minute"/> component.
        /// </summary>
        Minute,

        /// <summary>
        /// The <see cref="DateTime.Second"/> component.
        /// </summary>
        Second,

        /// <summary>
        /// The <see cref="DateTime.Millisecond"/> component.
        /// </summary>
        Millisecond,

        /// <summary>
        /// The <see cref="DateTime.Date"/> component.
        /// </summary>
        Date,

        /// <summary>
        /// The <see cref="DateTime.TimeOfDay"/> component.
        /// </summary>
        TimeOfDay,

        /// <summary>
        /// The <see cref="DateTime.Day"/> component.
        /// </summary>
        Day,

        /// <summary>
        /// The <see cref="DateTime.DayOfWeek"/> component.
        /// </summary>
        DayOfWeek,

        /// <summary>
        /// The <see cref="DateTime.DayOfYear"/> component.
        /// </summary>
        DayOfYear
    }
}
