﻿namespace Telerik.Core
{
    /// <summary>
    /// Provides intuitive values which describe common move animation scenarios.
    /// For example LeftIn means that the animated element is moving left and is coming in view.
    /// </summary>
    public enum MoveDirection
    {
        /// <summary>
        /// Left in.
        /// </summary>
        LeftIn,

        /// <summary>
        /// Left out.
        /// </summary>
        LeftOut,

        /// <summary>
        /// Right in.
        /// </summary>
        RightIn,

        /// <summary>
        /// Right out.
        /// </summary>
        RightOut,

        /// <summary>
        /// Top in.
        /// </summary>
        TopIn,

        /// <summary>
        /// Top out.
        /// </summary>
        TopOut,

        /// <summary>
        /// Bottom in.
        /// </summary>
        BottomIn,

        /// <summary>
        /// Bottom out.
        /// </summary>
        BottomOut
    }
}